#include <avr/pgmspace.h>  // Needed to store stuff in Flash using PROGMEM
#include "FastLED.h"       // Fastled library to control the LEDs


#define NUM_LEDS 300
#define NUM_LEDS_Strip 15
#define NUM_Strips 20

#define LED_PIN 3
CRGB leds[NUM_LEDS];

uint32_t Comet[3][5]={{0x00F0F0F0,0x00404040,0x00202020,0x00101010,0x00080808},{0x00F0F0F0,0x00501050,0x00301030,0x00100E10,0x000A0810},{0x00FF0000,0x00808000,0x00008000,0x00004080,0x0000FF}};
void setup() {
  Serial.begin (115200);
  FastLED.addLeds<WS2812,LED_PIN,GRB>(leds, NUM_LEDS);  // Init of the Fastled library
  Serial.println("----Init----");
}

void loop() {
  Serial.println("----Loop----");
  
  Palme(0xFF3200, 64,1); // Fire
  Palme(0XFFFFFF, 64,2); // Rainbow
  Palme(0XFFFFFF, 64,0); // Komet
  PalmeGlitter(0xFF3200, 64,1); // Fire
  PalmeGlitter(0X00FF00, 64,0); // Rainbow
  PalmeGlitter(0XFFFFFF, 64,0); // Komet
  Crackling(0xFF0000, 64,1); // Red
  Crackling(0XFFFFFF, 64,0); // Silver
  Crackling(0XFF3210, 64,0); // 
  Paeonie(0XFF0000, 64,0);
  Paeonie(0X00FF00, 64,0);
  Paeonie(0X00FFFF, 64,0);
  Kugel(0XFF3200, 0XFF3200, 128,0);
  Kugel(0X00FFFF, 0XFF3200, 128,0);
  Kugel(0X00FFFF, 0XFF00F0, 128,0);
  Wasserfall(0XFF3200,128,1);
  Wasserfall(0XFF3204, 128,1);
  Wasserfall(0XFF3208, 128,1);
  Wasserfall(0XFF3210, 128,1);
  delay (1000);
}



void Palme(uint32_t c, uint8_t wait,uint8_t band) 
{
  uint16_t i,s, Beginn;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[NUM_LEDS_Strip];

  //Serial.println("----ColorPoint----");

  Start=micros();
  //for( i=13; i<NUM_LEDS; i++) {
      Schablone[0]=0;
      Schablone[1]=c & Comet[band][4];
      Schablone[2]=c & Comet[band][3];
      Schablone[3]=c & Comet[band][2];
      Schablone[4]=c & Comet[band][1];
      Schablone[5]=c & Comet[band][0];
      if (band!=2) {
        Schablone[6]=c & 0xFFFFFF;
      }
      else {
        Schablone[6]=c & 0x000000;       
      }
      Beginn=6;
  //}

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[n]; 
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  //Zeit:1479974 µs
  //Zeit:1479962 µs
  //Zeit:1479962 µs
  return;
}

  void PalmeGlitter(uint32_t c, uint8_t wait,uint8_t band){
  uint16_t i,s,p, Beginn, Tail;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[4][NUM_LEDS_Strip];

  //Serial.println("----ColorPoint----");

  Start=micros();
  for (s=0;s<4;s++){
    for (i=0;i<NUM_LEDS_Strip;i++){
      Schablone[s][i]=0x000000;
    }
    
  }
  
  for (s=0;s<4;s++){
 
        Schablone[s][4]=0;
        Schablone[s][5]=c & Comet[band][4];
        Schablone[s][6]=c & Comet[band][3];
        Schablone[s][7]=c & Comet[band][2];
        Schablone[s][8]=c & Comet[band][1];
        Schablone[s][9]=c & Comet[band][0];
        if (band!=2) {
          Schablone[s][10]=c & 0xFFFFFF;
        }
        else {
          Schablone[s][10]=c & 0x000000;       
        }
        Beginn=10; p=0; Tail=4;
  }
  
  Schablone[0][3]=Comet[band][0];
  Schablone[0][1]=Comet[band][0];
  Schablone[0][0]=0x000000;
  Schablone[1][3]=Comet[band][0];
  Schablone[1][0]=0x000000;
  Schablone[2][2]=Comet[band][0];
  Schablone[2][1]=Comet[band][0];
  Schablone[3][1]=Comet[band][0];
  Schablone[3][0]=0x000000;
 

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=Tail;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[p][n]; 
          Serial.println(p);
          p++;
          p=p & 0x03;
        } 
      }
      Led_Index++;
    }
    //FastLED.show();    
    //delay(10);
    
    Led_Index=Frame-Tail;
    for(n=0;n<Tail;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          if (random(10)<3) leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);    
    Led_Index=Frame-Tail;
    for(n=0;n<Tail;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(wait);  

  } 
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  return;
}

void Crackling (uint32_t c, uint8_t wait,uint8_t band){
  uint16_t i,s,p, Beginn;// Tail;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[4][NUM_LEDS_Strip];

  Start=micros();
  for (s=0;s<4;s++){
    for (i=0;i<NUM_LEDS_Strip;i++){
      if (random(10)<4){
        Schablone[s][i]=c;      
      }
      else{
        Schablone[s][i]=0x000000;
      }
    }
  }

  Beginn=10; p=0; 

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){    
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){ 
          if (random(10)<4) leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);   
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){   
          if (Led_Index+(s*NUM_LEDS_Strip)>299) Serial.println("Fehler löschen");   
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(20); 
    ///----
        Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){ 
          if (random(10)<4) leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[p][n]; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(10);   
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){   
          if (Led_Index+(s*NUM_LEDS_Strip)>299) Serial.println("Fehler löschen");   
          leds[Led_Index+(s*NUM_LEDS_Strip)]=0x000000; 
          p++;
          if (p==4) p=0;
        } 
      }
      Led_Index++;
    }
    FastLED.show();   
    delay(wait);   
  } 
  
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  return;
}

void Paeonie(uint32_t c, uint8_t wait,uint8_t band) 
{
  uint16_t i,s, Beginn;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[NUM_LEDS_Strip];

  //Serial.println("----ColorPoint----");

  Start=micros();
  //for( i=13; i<NUM_LEDS; i++) {
      Schablone[0]=0;
      Schablone[1]=0x000000;//c & Comet[band][4];
      Schablone[2]=0x000000;//c & Comet[band][3];
      Schablone[3]=c & Comet[band][4];
      Schablone[4]=c & Comet[band][3];
      Schablone[5]=c & Comet[band][0];
      if (band!=2) {
        Schablone[6]=c & 0xFFFFFF;
      }
      else {
        Schablone[6]=c & 0x000000;       
      }
      Beginn=6;
  //}

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
          leds[Led_Index  ]=Schablone[n]; 
          leds[Led_Index+(NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(2*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(3*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(16*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(17*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(18*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(19*NUM_LEDS_Strip)]=Schablone[n]; 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  //Zeit:1479974 µs
  //Zeit:1479962 µs
  //Zeit:1479962 µs
  return;
}

void Kugel(uint32_t c, uint32_t d,  uint8_t wait,uint8_t band) 
{
  uint16_t i,s, Beginn;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[NUM_LEDS_Strip];

  //Serial.println("----ColorPoint----");

  Start=micros();
  //for( i=13; i<NUM_LEDS; i++) {
      Schablone[0]=0;
      Schablone[1]=d & Comet[band][3];;
      Schablone[2]=d & Comet[band][0];;
      Schablone[3]=0;
      Schablone[4]=0;
      Schablone[5]=0;
      Schablone[6]=0;
      Schablone[7]=0;
      Schablone[8]=c & Comet[band][3];
      Schablone[9]=c & Comet[band][0];
      if (band!=2) {
        Schablone[10]=c & 0xFFFFFF;
      }
      else {
        Schablone[10]=c & 0x000000;       
      }
      Beginn=10;
  //}

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
        for(s=0; s<NUM_Strips;s++){      
          leds[Led_Index+(s*NUM_LEDS_Strip)]=Schablone[n]; 
        } 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  //Zeit:1479974 µs
  //Zeit:1479962 µs
  //Zeit:1479962 µs
  return;
}

void Wasserfall(uint32_t c,  uint8_t wait,uint8_t band) 
{
  uint16_t i,s, Beginn;
  int Frame, Led_Index,n;  
  uint32_t Start, Stop, Time;
  unsigned long Schablone[NUM_LEDS_Strip];

  //Serial.println("----ColorPoint----");

  Start=micros();
  //for( i=13; i<NUM_LEDS; i++) {
      Schablone[0]=0;
      Schablone[1]=c & Comet[band][4];
      Schablone[2]=c & Comet[band][4];
      Schablone[3]=c & Comet[band][4];
      Schablone[4]=c & Comet[band][4];
      Schablone[5]=c & Comet[band][4];
      Schablone[6]=c & Comet[band][3];
      Schablone[7]=c & Comet[band][3];
      Schablone[8]=c & Comet[band][2];
      Schablone[9]=c & Comet[band][2];
      Schablone[10]=c & Comet[band][1];
      Schablone[11]=c & Comet[band][1];
      Schablone[12]=c & Comet[band][0];
      Schablone[13]=c & Comet[band][0];
      
      if (band!=2) {
        Schablone[14]=c & 0xFFFFFF;
      }
      else {
        Schablone[14]=c & 0x000000;       
      }
      Beginn=14;
  //}

  for (Frame=1-Beginn;Frame<NUM_LEDS_Strip;Frame++){
    Led_Index=Frame;
    for(n=0;n<=Beginn;n++){
      if ((Led_Index>=0)&&(Led_Index<NUM_LEDS_Strip)){
          leds[Led_Index+(9*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(10*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(13*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(14*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(17*NUM_LEDS_Strip)]=Schablone[n]; 
          leds[Led_Index+(18*NUM_LEDS_Strip)]=Schablone[n]; 
      }
      Led_Index++;
    }
    FastLED.show();
    delay(wait);  
  } 
  
  Stop=micros();
  Serial.print("Zeit:");
  Serial.print(Stop-Start);
  Serial.println(" µs"); 
  //Zeit:1479974 µs
  //Zeit:1479962 µs
  //Zeit:1479962 µs
  return;
}
